#include "stdafx.h"

BYTE Transparency;
TCFG CFG;
TPluginInfo PluginInfo;
TAstonData	AData;
int LockPosition = 0;
int ZOrder = 0;
int Frames = 0;
AstonWND* firstWND = NULL;
TNode run_node = {};
char TextFormat[MAX_PATH];
char BgSkin[MAX_PATH];
char GlassSkin[MAX_PATH];
RECT TextRect;
TFont Font;
COLORREF TextColor;
BOOL Shadow;
COLORREF ShadowColor;
UINT TextAlign;
TPicture pic;
POINT VolumeOffset;
RECT FixClick;
bool show = false;
HMODULE hInstance; 
HICON DefIcon = 0;
#pragma comment(linker,"/entry:DllMain")

//*****************************************************************************//
BOOL APIENTRY DllMain(HANDLE hModule, 
                      DWORD  ul_reason_for_call, 
                      LPVOID lpReserved)
{
    if (ul_reason_for_call == DLL_PROCESS_ATTACH)
    {
      DisableThreadLibraryCalls(hInstance = (HMODULE)hModule);
    }
    return TRUE;
}  
//*****************************************************************************//
__declspec(naked) INT __fastcall SwapColor(INT a)
{
  __asm
  {
    MOV  EAX,ECX
    BSWAP EAX
    SHR   EAX,8
    RET
  }
}
//*****************************************************************************//
char* GetNextDisk(char* p)
{
  if (IsEmpty(p)) return NULL;
  for (INT i=0; i < MAX_PATH; i++)
  {
    if (p[0] == 0)
    {
      p++;
      return p;
    }
    p++;
  }
  return NULL;
}
//*****************************************************************************//

LONG WINAPI WndProc(HWND window, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch (message)
    {
    case WM_TIMER:
        {
          if (wParam == TimerID)
          {
            AstonWND* w = FindWND(window);
            if (w) UpdateDisksInfo(w);
          }
        }
        return 1;
    case WM_LBUTTONDOWN:      // Stupid fix 
        {
          if (AData.Ring1->DblClk) break; // open Double click only
          GetWindowRect(window, &FixClick);
        }
        return 1;

    case WM_LBUTTONUP:
        {
            if (AData.Ring1->DblClk) break; // open Double click only
            RECT r;
            GetWindowRect(window, &r);
            if (EqualRect(&FixClick, &r))   //no draging window. TODO:  fix in 1.9.3
            {
                OpenDrive(window);
            }            
        }
        return 1;
    case WM_LBUTTONDBLCLK:
        {
            if (AData.Ring1->DblClk) OpenDrive(window);
            return 1;
        }

    case WM_RBUTTONUP:
        {
            ShowContextMenu(window);           
        }
        return 1;
    case WM_EXITSIZEMOVE:
        {
            AstonWND* a = FindWND(window);
            if (a) SaveWndPos(a);
        }
        return 1;
    }
    return 0;
}

//*****************************************************************************//
AstonWND* CreateWND(AstonWND* Parent, char* disk_root)
{
  DWORD flag = AWS_FADESTYLE;
  int trans1 = 0;  // Transparency for layer 
  if (LockPosition) flag |= AWS_LOCKPOS;
  if (ZOrder == 0)
  {
      flag |= AWS_DRAWWALLPAPER;
      trans1 = Transparency;  // if ZOrder = Desktop
  }
  else
  {
       flag |= AWS_LAYERED;
  }
  AstonWND* w = (AstonWND *)CreateAstonWND(0, 0, AData.Desktop, ZOrder, flag, &WndProc, AData.Desktop, Transparency);
  if (w == NULL) return NULL;
  TDISTINFO* info = (TDISTINFO*)Amalloc(sizeof(TDISTINFO));
  if (!info) return NULL;
  if (AData.Ring1->DblClk) // TODO fix in 1.9.3
  {
    DWORD ex = GetClassLong(w->hwnd(), GCL_STYLE);
    SetClassLong(w->hwnd(), GCL_STYLE, ex | CS_DBLCLKS);
  }
  RtlZeroMemory(info, sizeof(TDISTINFO));
  info->pic_index = -1;
  w->SetUserData(long(info));  
  lstrcpy(info->root, disk_root); 
  if (Parent != NULL)
  {    
      TDISTINFO* par = userdata(Parent);
      par->next = w; 
  }
  int bg = w->AddLayer(0, 0, 0, BgSkin, LAYER_DRAG, trans1);
  info->volume_layer = -1;
  if (pic.IconType>0)
  {
    //Layer for infill bar
    if (pic.IconType == PICTURE_BMP) // bmp or jpg
    info->volume_layer = 
        w->CreateCustomLayer(0, VolumeOffset.x, VolumeOffset.y, pic.Width/Frames, pic.Height, LAYER_DRAG, trans1);
    else        // png format
    info->volume_layer = 
        w->CreateCustomLayer(0, VolumeOffset.x, VolumeOffset.y, pic.Width/Frames, pic.Height, LAYER_LAYERED | LAYER_DRAG, trans1);

    
  }
  //Layer for text
  info->text_layer = 
      w->CreateCustomLayer(0, TextRect.left, TextRect.top, TextRect.right - TextRect.left, TextRect.bottom - TextRect.top, LAYER_LAYERED | LAYER_DRAG, trans1);
  //Layer for glass
  int glass = w->AddLayer(0, 0, 0, GlassSkin, LAYER_DRAG | LAYER_TRANSPARENT /* tansparent for mouse click */, trans1);  

  if (bg < 0 && info->volume_layer<0 && glass<0 && IsEmpty(TextFormat) && pic.IconType<=0)
  {
      bg = w->CreateCustomLayer(0, 0, 0, 48, 48, LAYER_LAYERED | LAYER_DRAG, trans1);
      HICON ico = (HICON)LoadImage(hInstance,  LPCSTR(IDI_ICON1), IMAGE_ICON, 0, 0, LR_DEFAULTCOLOR); // load default icon
      if (bg >= 0)
      {
        Ppaint pp = w->LayerPaint_Begin(bg);
        DrawIconEx(pp->DC, 0, 0,  ico, 48, 48, 0, 0, DI_NORMAL);
        w->LayerPaint_End(pp);
      }
      DeleteObject(ico);
  }
  GetDiskInfo(w);
  CreateInfoText(w);
  info->timer = SetTimer(w->hwnd(), TimerID, 1000, NULL) != 0;
  // TODO add hint
  return w;
}

//*****************************************************************************//
AstonWND* InitPlugin()
{
  AstonWND* result = NULL;
  AstonWND* w = NULL;
  //--------------
  char* tmp = NULL;
  tmp = (char*)Amalloc(512);
  RtlZeroMemory(tmp, 512);
  GetLogicalDriveStrings(500, tmp);
  char* p = tmp;
  for (;;)
  {
    if (p[0]!=0)
    {
      if (p[0]>'Z') p[0] = p[0]- 0x20;
      UINT type = GetDriveType(p);
      if ((type == DRIVE_FIXED)||
          (type == DRIVE_RAMDISK))
      {
        w = CreateWND(w, p);
        if (result == 0 && w != NULL) result = w;
      }
    }
    else break;
    p = GetNextDisk(p);
    if  (p==NULL || p[0] == 0) break;
  }

 Afree(tmp);
 return result;
}
//*****************************************************************************//
void ReadConfig()
{
  TCFG CFG = {0};
  char tmp[MAX_PATH];
  OpenCFGr(AData.PluginsCFG, &CFG);
  FindSection(szSectionName, 0, &CFG);
    GetCFGString(szTextFormat, "", TextFormat, MAX_PATH-1,  &CFG);
    ZOrder = GetCFGInt(szZOrder, 0, &CFG);
    LockPosition = GetCFGBool(szLockPosition, FALSE, &CFG);
    Transparency = (BYTE)GetCFGInt(szTransparency, 0, &CFG);
    // skin
    GetCFGString(szBgSkin, "", BgSkin, MAX_PATH, &CFG);
    GetCFGString(szGlassSkin, "", GlassSkin, MAX_PATH, &CFG);
    GetCFGString(szSkin, "", tmp, MAX_PATH, &CFG);
    pic.FileName = tmp;
    pic.Options = PIC_NOCACHE;
    LoadImageEx(&pic);
    Frames = GetCFGInt(szFrames, 1, &CFG);
    CheckInt(&Frames, 1, 9999,  1);
    VolumeOffset.x = GetCFGInt(szProgressOffsetX, 0, &CFG);
    VolumeOffset.y = GetCFGInt(szProgressOffsetY, 0, &CFG);
    // Fonts and color
    GetCFGRect(szTextRect, &TextRect, &CFG);
    GetCFGFont(szFont, &Font, &CFG);
    if (Font.Size == 0) Font.Size = 8;
    GetFontHandle(&Font, (HFONT)GetStockObject(ANSI_VAR_FONT));
    TextColor = SwapColor(GetCFGHex(szTextColor, 0, &CFG));
    Shadow = GetCFGBool(szShadow, FALSE, &CFG);
    ShadowColor = SwapColor(GetCFGHex(szShadowColorH, 0, &CFG));
    TextAlign = GetCFGInt(szTextAlign, 1, &CFG);
  CloseCFGr(&CFG);
}
//*****************************************************************************//
extern "C" void WINAPI InitGlobalModule(const PAstonData AstonData)
{

  if (AstonData->cbsize < sizeof(TAstonData)) return;
  RtlMoveMemory(&AData, AstonData, sizeof(TAstonData));
  run_node.NodeType = 1;
  run_node.Path = (char*)Amalloc(MAX_PATH);
  ReadConfig();
  firstWND = InitPlugin();
  if (firstWND != NULL)
  {
      AstonData->Node->Wnd = firstWND->hwnd();
      SetWindowsPos(firstWND);
      ShowAllWindows(firstWND, 1);
  }


}
//*****************************************************************************//

extern "C" void WINAPI DoneModule(void)
{
    if (firstWND!=NULL)
    {
        for (;;)
        {
          if (firstWND == NULL) break;
          TDISTINFO* w_inf = userdata(firstWND);
          if (w_inf->timer) KillTimer(firstWND->hwnd(), TimerID);  
          DestroyWindow(firstWND->hwnd());
          if (!w_inf) break;
          firstWND = w_inf->next;
          Afree((void*)w_inf);
        }
    }
    if (run_node.Path != NULL) Afree((void*)run_node.Path);

    if (pic.Handle != 0) DeleteObject(pic.Handle);
    if (pic.Mask != 0) DeleteObject(pic.Mask);
    FreeFont(&Font);
}
//*****************************************************************************//

extern "C" PPluginInfo WINAPI GetPluginInfo(void)
{
    PluginInfo.cbSize = sizeof(TPluginInfo);
    PluginInfo.szName = szPLGName;
    PluginInfo.szDescription = szHelp;
    PluginInfo.szSection = szSectionName;
    PluginInfo.nKeyCount = sizeof(Keys)/sizeof(TKey);
    PluginInfo.Keys = (PKey)&Keys;
    return &PluginInfo;
}
//
