#include "stdafx.h"

extern int Frames;
extern TAstonData	AData;
extern TNode run_node;
extern AstonWND* firstWND;
extern char TextFormat[MAX_PATH];
extern UINT TextAlign;
extern RECT TextRect;
extern TFont Font;
extern COLORREF TextColor;
extern BOOL Shadow;
extern COLORREF ShadowColor;
extern POINT VolumeOffset;
extern TPicture pic;

//*****************************************************************************//

TDISTINFO* userdata(AstonWND* a)
{
    return (TDISTINFO*)a->GetUserData();
}
//*****************************************************************************//

TDISTINFO* FindWNDinfo(HWND wnd)
{    
    if (firstWND == NULL) return NULL;
    AstonWND* w = firstWND;
    for (;;)
    {
      if (w == NULL) break;
      TDISTINFO* w_inf = userdata(w);
      if (wnd == w->hwnd()) return w_inf;
      if (!w_inf) break;
      w = w_inf->next;
    }
    return NULL;
}
//*****************************************************************************//

AstonWND* FindWND(HWND wnd)
{    
    if (firstWND == NULL) return NULL;
    AstonWND* w = firstWND;
    for (;;)
    {
      if (w == NULL) break;
      TDISTINFO* w_inf = userdata(w);
      if (wnd == w->hwnd()) return w;
      if (!w_inf) break;
      w = w_inf->next;
    }
    return NULL;
}

//*****************************************************************************//
char* find_sring(char* txt, char* find)
{
  INT l = lstrlen(find);
  INT i;
  if (IsEmpty(txt)) return NULL;
  for (;;)
  {
    if ((txt[0] & 223) == (find[0] & 223))  
    {
      for (i=0; i<l;i++)
      {
        if (txt[i] == 0) return NULL;
        if ((txt[i] & 223) != (find[i] & 223)) break;
        if (((txt[i] & 223) == (find[i] & 223)) && (i == (l-1))) return txt;
      }
    }
    if (txt[0] == 0) return NULL; 
    txt++;
  }
}
//*****************************************************************************//

void StrReplace(char* t, char* f, char* r)
{
  char* tmp;
  if (IsEmpty(t) || IsEmpty(f) || IsEmpty(r)) return;  
  char* p = t;
  INT z = lstrlen(f);
  INT nz = lstrlen(r);
  for (;;)
  {
    p = find_sring(p, f);
    if (IsEmpty(p)) break;
    tmp = NULL;
    tmp = (char*)Amalloc(lstrlen(&p[z])+1);
    lstrcpy(tmp, &p[z]);
    lstrcpy(p, r);
    lstrcat(p, tmp);
    Afree(tmp);
    p = &p[nz];
  }
  
}
//*****************************************************************************//

bool GetDiskInfo(AstonWND* w)
{
  if (w == NULL) return false;
  TDISTINFO* info = userdata(w);
  if (info == NULL) return false;
  char tmp[MAX_PATH];
  DWORD NotUsed, VolFlags;
  INT64 Free = 0;
  INT64 Total = 0;
  if (GetVolumeInformation(info->root, tmp, 64, NULL, &NotUsed, &VolFlags, NULL, 0))
    lstrcpy(info->name, tmp);
  else
  {
    info->name[0] = 0;
    return false;
  }
  if (GetDiskFreeSpaceEx(info->root,  (PULARGE_INTEGER)&Free, (PULARGE_INTEGER)&Total, NULL))
  {
    info->free = Free;
    info->total = Total;
    if (Total != 0)
    {
      bool rez = false;
      if (Free != info->oldfree)
      {
        rez = true;
      }
      info->oldfree = Free;
      int i = (int)(Frames * Free/Total); 
      if ((i != info->pic_index) || (Free != info->oldfree))
      {
        info->pic_index = i;  
        // draw infill bar
        int l = pic.Width/Frames;
        int index = info->pic_index;
        if (pic.IconType > 0 && info->volume_layer >= 0 && info->pic_index >= 0)
        {
          Ppaint pp = w->LayerPaint_Begin(info->volume_layer); 
          {

            if (pic.IconType == PICTURE_BMP_ALPHA)
              AlphaBlt(pp->DC, 0,0, 
                       l, pic.Height,
                       (HBITMAP)pic.Handle, l * index, pic.Width, pic.Height,
                       (BYTE*)pic.dwReserved);
            else
            {

              HDC dcMem1 = CreateCompatibleDC(pp->DC);
              HGDIOBJ old_bmp1 = SelectObject(dcMem1, pic.Mask);
              BitBlt(pp->DC, 0, 0, l, pic.Height, dcMem1, l * index, 0, SRCAND);
              SelectObject(dcMem1, pic.Handle);
              BitBlt(pp->DC, 0, 0, l, pic.Height, dcMem1, l * index, 0, SRCPAINT);
              SelectObject(dcMem1, old_bmp1);
              DeleteDC(dcMem1); 
            }
          }
          w->LayerPaint_End(pp);
        }
        //----------------
      }
      return rez;
    }
  }
  return false;
}
//*****************************************************************************//

void ShowAllWindows(AstonWND* w, int ShowFlag)
{
    for (;;)
    {
      if (w == NULL) break;
      TDISTINFO* w_inf = userdata(w);
      w->Show(ShowFlag);
      if (!w_inf) break;
      w = w_inf->next;
    }
}
//*****************************************************************************//

void UpdateDisksInfo(AstonWND* w)
{
      if (w == NULL) return;
      TDISTINFO* w_inf = userdata(w);
      if (!w_inf) return;
      if (GetDiskInfo(w))
      {
        CreateInfoText(w);
        w->ReDraw();
      }
}
//*****************************************************************************//

void SetWindowsPos(AstonWND* w)
{
    if (w==NULL) return;
    AstonWND* tw = w;
    RECT r;
    GetClientRect(w->hwnd(), &r);
    INT x = 20;
    INT y = 20;
    for (;;)                    // Set default position
    {
      if (w == NULL) break;
      TDISTINFO* w_inf = userdata(w);
      if (!w_inf) break;
      w->MoveWindow(x,y);
      w = w_inf->next;
      y = y + r.bottom + 20;
      if (y > 400)
      {
        y = 20;
        x = x + r.right + 20;
      }
    }
    TCFG CFG = {0};
    char tmp[4];
    OpenCFGr(AData.PluginsCFG, &CFG);
    RtlZeroMemory(tmp, 4);
    FindSection(szSectionName, 0, &CFG);
    w = tw;
    for (;;)                // read positions from config
    {
      if (w == NULL) break;
      TDISTINFO* w_inf = userdata(w);
      if (!w_inf) break;    
      tmp[0] = w_inf->root[0];
      tmp[1] = 'X';
      x = GetCFGInt(tmp, -5555, &CFG);
      tmp[1] = 'Y';
      y = GetCFGInt(tmp, -5555, &CFG);
      if ( x != -5555 && y != -5555) w->MoveWindow(x,y);
      w = w_inf->next;
    }
  CloseCFGr(&CFG);
}
//*****************************************************************************//

void DrawDiskMem(INT64 j, char* st, BOOL f)
{
  INT64 x;
  UINT  y,k;
  INT64 i;
  i = j/1024;
  if (i>1025)
  {
    i = i/1024;
    if (i > 1025)
    { //Gb
       x = i/1024;
       y = (UINT)(i - (x * 1024)) * 100/1024;
       k = UINT(x); 
       if (f) wsprintf(st, "%u,%u Gb", k, y);
       else wsprintf(st, "%u,%u", k, y);
         
    }
       else
    { //Mb
       if (f) wsprintf(st, "%lu Mb" , i);
       else wsprintf(st, "%lu" , i);
    }
  }
    else
  { //Kb ??? you have ZX-SPECTRUM??
       if (f) wsprintf(st, "%lu Kb" , i);
       else wsprintf(st, "%lu" , i);
  }
}
//*****************************************************************************//

void OpenDrive(HWND wnd)
{
  TDISTINFO* info = FindWNDinfo(wnd);
  if (info)
  {
      lstrcpy(run_node.Path, info->root);
      ::SendMessage(AData.MainWindow, CM_EXECUTENODE, 0, (LPARAM)&run_node);
  }
}
//*****************************************************************************//

void ShowContextMenu(HWND window)
{
  char tmp[MAX_PATH];
  HMENU Menu = CreatePopupMenu();
  AppendMenu(Menu,  MF_ENABLED | MF_STRING, 500, szOpen);
  AppendMenu(Menu,  MF_ENABLED | MF_STRING,  502, szProperties);
  AppendMenu(Menu,  MF_SEPARATOR, 0, NULL);
  AppendMenu(Menu,  MF_ENABLED | MF_STRING, 501, szSettings);
  POINT p; 
  GetCursorPos(&p);
  ::SendMessage(AData.MainWindow, CM_ENTERMODAL, 0,0);
  int i = TrackPopupMenuEx(Menu, TPM_RETURNCMD, p.x, p.y, window, NULL);
  DestroyMenu(Menu);
  ::SendMessage(AData.MainWindow, CM_LEAVEMODAL, 0,0);
  switch (i)
  {
  case 500:
    {       
        OpenDrive(window);
    }
    break;
  case 501:
      {
         tmp[0] = '/';
         lstrcpy(&tmp[1], AData.Node->Path);
         ::SendMessage(AData.MainWindow, CM_SETUPASTON, 0, (LPARAM)tmp);
      }
      break;
  case 502:
    {
        TDISTINFO* info = FindWNDinfo(window);
        if (info)
        {
              SHELLEXECUTEINFO ex = {};
              ex.cbSize  = sizeof(SHELLEXECUTEINFO);
              ex.fMask = SEE_MASK_INVOKEIDLIST;
              ex.hwnd  = GetDesktopWindow();
              ex.lpVerb = "properties";
              ex.lpFile = info->root;
              ex.nShow = 1;
              ShellExecuteEx(&ex);
        }
    }
 }

}
//*****************************************************************************//

void CreateInfoText(AstonWND* w)
{
  if (w == NULL) return;
  TDISTINFO* w_inf = userdata(w);
  char st[64];
  char tmp[MAX_PATH];
  lstrcpy(&tmp[0], TextFormat);
  StrReplace(&tmp[0], "\\r\\n", "\x0D\x0A");
  StrReplace(&tmp[0], "%name%", w_inf->name);
  DrawDiskMem(w_inf->free, st, TRUE);
  StrReplace(&tmp[0], "%free%", st);

  DrawDiskMem(w_inf->total, st, FALSE);
  StrReplace(&tmp[0], "%freeEx%", st);

  DrawDiskMem(w_inf->total, st, TRUE);
  StrReplace(&tmp[0], "%total%", st);

  DrawDiskMem(w_inf->total - w_inf->free, st, TRUE);
  StrReplace(&tmp[0], "%used%", st);

  DrawDiskMem(w_inf->total - w_inf->free, st, false);
  StrReplace(&tmp[0], "%usedEx%", st);

  INT64 i;
  i = (w_inf->free * 100)/w_inf->total;
  wsprintf(st, "%lu" , i);
  StrReplace(&tmp[0], "%p_free%", st);

  i = 100- i;
  wsprintf(st, "%u" ,i);
  StrReplace(&tmp[0], "%p_used%", st);


  lstrcpy(st, w_inf->root);
  st[1] = 0;
  StrReplace(&tmp[0], "%index%", st);
  if (w_inf->text_layer < 0) return;

  UINT flag =  DT_LEFT | DT_WORDBREAK | DT_EXPANDTABS | DT_NOPREFIX;
  switch (TextAlign) 
  {
  case 1: flag = DT_CENTER | DT_WORDBREAK | DT_EXPANDTABS | DT_NOPREFIX;
    break;
  case 2: flag = DT_RIGHT | DT_WORDBREAK | DT_EXPANDTABS | DT_NOPREFIX;
    break;
  }
  RECT r;
  SetRect(&r, 0, 0, TextRect.right - TextRect.left, TextRect.bottom - TextRect.top);
  Ppaint pp = w->LayerPaint_Begin(w_inf->text_layer); 
  w->DrawTextA(pp->DC, tmp, &r, Font.Handle, flag, TextColor, Shadow, ShadowColor);
  w->LayerPaint_End(pp);
}
//*****************************************************************************//

void SaveWndPos(AstonWND* w)
{
  if (!w) return;
  TCFG CFG = {0};
  char tmp[4]={};
  RECT r;
  TDISTINFO* w_inf = userdata(w);
  if (!w_inf) return;
  GetWindowRect(w->hwnd(), &r);
  OpenCFGw(AData.PluginsCFG, &CFG);
  FindSection(szSectionName, SECTION_CREATE_ALWAYS, &CFG);
  tmp[0] = w_inf->root[0];
  tmp[1] = 'X';
  SetCFGInt(tmp, r.left, &CFG);
  tmp[1] = 'Y';
  SetCFGInt(tmp, r.top, &CFG);
  CloseCFGw(AData.PluginsCFG, FALSE, &CFG);
}

